function RunnableFunctionWrapper(aFunction)
{
  this.run = aFunction;
}

RunnableFunctionWrapper.prototype =
{
  QueryInterface: function(aIID)
  {
    if (aIID.equals(Components.interfaces.nsIRunnable) ||
        aIID.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  }
};



function CmguiReady()
{
}


CmguiReady.prototype =
{
  QueryInterface: function(aIID)
  {
    if (
        aIID.equals(Components.interfaces.CmguiIApplicationBootstrap) ||
        aIID.equals(Components.interfaces.CmguiISceneViewerResultMonitor) ||
	aIID.equals(Components.interfaces.nsISupports)
       )
    {
      return this;
    }
    throw Components.results.NS_NOINTERFACE;
  },

  cmguiReady: function(cdf)
  {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

    window.commandData = cdf.createCommandData();

    // for a switch in the comfile that stops cmgui opening graphics windows
    window.commandData.executeCommand("$ZINC=1");


    // Note the downloading is asynchronous so we need to wait for all of these to finish before
    // continueing. The DownloadMonitor object keeps track of the number of downloads in progress.
    // A counter will be incremented when an asynchronous download is started
    // and decremented when download is complete and the memory block defined
    // When counter returns to 0 the callback function will be executed, ie carry on.
    // 
    // Note there is a very small race condition here. The first download could complete
    // before the second has started.
    var dm = Components.classes["@physiome.org/mozCmgui/mozDownloadMonitor;1"]
                      .createInstance(Components.interfaces.mozIDownloadMonitor);
    dm.onDownloadsCompleted = new RunnableFunctionWrapper(runComfile);

    window.mozCmguiDefineMemoryBlock(commandData, dm, 'chrome://mozcmgui/content/torso/torso.com', 'torso.com');
    window.mozCmguiDefineMemoryBlock(commandData, dm, 'chrome://mozcmgui/content/torso/body.exnode', '/body.exnode');
    window.mozCmguiDefineMemoryBlock(commandData, dm, 'chrome://mozcmgui/content/torso/body_heart.exelem', '/body_heart.exelem');
    window.mozCmguiDefineMemoryBlock(commandData, dm, 'chrome://mozcmgui/content/torso/body_llung.exelem', '/body_llung.exelem');
    window.mozCmguiDefineMemoryBlock(commandData, dm, 'chrome://mozcmgui/content/torso/body_rlung.exelem', '/body_rlung.exelem');
    window.mozCmguiDefineMemoryBlock(commandData, dm, 'chrome://mozcmgui/content/torso/body_muscle.exelem', '/body_muscle.exelem');
    window.mozCmguiDefineMemoryBlock(commandData, dm, 'chrome://mozcmgui/content/torso/body_fat.exelem', '/body_fat.exelem');
    window.mozCmguiDefineMemoryBlock(commandData, dm, 'chrome://mozcmgui/content/torso/body_torso.exelem', '/body_torso.exelem');
  },

  sceneViewerReady: function(sceneViewer)
  {
    // This is just a sample of how this interface could be put on the cmguiReady object.
    // However in this demo we define scene1Ready object to handle the initialisation of the scene following
    // downloading of the content and execution of the command file. 
  }
};



function scene1Ready()
{
}


scene1Ready.prototype =
{
  QueryInterface: function(aIID)
  {
    if (
        aIID.equals(Components.interfaces.CmguiISceneViewerResultMonitor)
       )
    {
      return this;
    }
    throw Components.results.NS_NOINTERFACE;
  },

  sceneViewerReady: function(sceneViewer)
  {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    window.plugin.resizeMonitor =
      mozCmguiProxyToMain(new mozCmguiResizeMonitor(sceneViewer, window.plugin),
                  Components.interfaces.mozIPluginResizeMonitor);

    // Once we have scene viewers, we need to use a function calling mechanism that avoids
    // deadlocks on the Microsoft Windows Platform, on other platforms this wrapper executes 
    //the function as before.
    mozCmguiRunSafe(function(){sceneViewer.setBackgroundColourRGB(1.0, 1.0, 1.0);});
    mozCmguiRunSafe(function(){sceneViewer.setWindowSize(window.plugin.width, window.plugin.height);});
    mozCmguiRunSafe(function(){sceneViewer.viewAll();});
    mozCmguiRunSafe(function(){sceneViewer.setLookatParametersNonSkew(-3.0125, -1688.29, 285, -3.0125, -3.69165, 285, 0, 0, 1 );});
  }
};

function SelectionHandler()
{
}

SelectionHandler.prototype =
{
  QueryInterface: function(aIID)
  {
    if (aIID.equals(Components.interfaces.CmguiIEventHandler) ||
        aIID.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },

  onEvent: function()
  {
    var data = {};
    var count = {};
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    window.commandData.getSelectedNodes(data, count);
    data = data.value;
    // Data is a standard Javascript array of nodes.
    alert("Selection occurred, count " + data.length);
  }
}

function runComfile()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
  //window.commandData.executeCommand('print \"runComfile just entered\\n\"');
  window.commandData.executeCommand("$example = \"memory:\";");
  window.commandData.executeCommand("open comfile memory:torso.com exec;");
  window.commandData.registerSelectionHandler(
    mozCmguiProxyToMain(new SelectionHandler(),
                        Components.interfaces.CmguiIEventHandler));

  var plugin = document.getElementById("generalplugin");
  window.plugin = plugin;
  var windowId = plugin.window;

  window.sceneViewer =
    window.commandData.createSceneViewer(windowId,
                                         mozCmguiProxyToMain(new scene1Ready(), Components.interfaces.CmguiISceneViewerResultMonitor));
}



function torsoInit()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

  var minVersion = "0.4.0";
  var maxVersion = "0.4.0";

  // Load the preparer first, to make sure the paths are right...
  Components.classes["@physiome.org/mozCmguiPreparer;1"]
	  .createInstance(Components.interfaces.nsISupports);
  
  var mcg = Components.classes["@physiome.org/mozCmgui;1"]
	  .createInstance(Components.interfaces.mozICmgui);
  window.mcg = mcg;
  mcg.launchCmgui(mozCmguiProxyToMain(new CmguiReady(), Components.interfaces.CmguiIApplicationBootstrap));
}

function torsoDestroy()
{
  window.plugin = null;
  window.commandData = null;
  window.sceneViewer = null;
  window.mcg = null;
}
